// wxWidgets GUI libs //
#include "wx/wxprec.h"
#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "wx/cmdline.h"
#include "wx/grid.h"
#include "wx/checkbox.h"

#include <fstream>

// lineeye LE library //
#include "LEU_LIB.h"

// my utils//
#include "MYLEU_Util.h"

// Window size //
#define MYWIN_WID 1000
#define MYWIN_HGT 700

// Grid //
#define MYG_NCOL 10
#define MYG_NROW_INI 20

// IDs //
#define ID_TIMER 1001
#define ID_MYGRID 2001
#define ID_BTN_RUN 101
#define ID_BTN_STOP 102
#define ID_BTN_CLEAR 103
#define ID_BTN_SAVE 104
#define ID_BTN_QUIT 105
#define ID_CHK_SOF 201
#define ID_CHK_PING 202
#define ID_CHK_IN_NAK 203
#define ID_TXT_RUN 301
#define ID_TXT_SOF 302
#define ID_TXT_TIME 303

// main application class //
class MyApp : public wxApp
{
 public:

    virtual bool OnInit();
};

// main window class //
class MyFrame : public wxFrame
{
 public:
	
    MyFrame(const wxString& title);
	~MyFrame();

    wxTimer timer;
	MyTrans USBT;

	int ndata;
	uint16_t f_filter;
	uint16_t last_SOF;
	
    void OnQuit(wxCommandEvent& event);
    void OnButton(wxCommandEvent& event);
    void OnTimer(wxTimerEvent& event);
	void OnCheck(wxCommandEvent& event);

 private:
    wxDECLARE_EVENT_TABLE();

    wxPanel *btnPanel;
	wxPanel *gridPanel;
	wxGrid *grid;

	wxStaticText *RunText;
	wxStaticText *SOFText;
	wxStaticText *TimeText;
	wxCheckBox *chk_SOF;
	wxCheckBox *chk_PING;
	wxCheckBox *chk_IN_NAK;

	void WriteLine(int lineNo, int disp);
	void InitSettings();
	int SetFilter();
	void SaveAsDialog();

};


enum
{
    // menu items
    Menu_Quit = wxID_EXIT
};

// GUI macros // 
wxBEGIN_EVENT_TABLE(MyFrame, wxFrame)
EVT_MENU(Menu_Quit,  MyFrame::OnQuit) // menu exit
EVT_TIMER(1001, MyFrame::OnTimer) // auto timer event
EVT_BUTTON(wxID_ANY, MyFrame::OnButton) // button functions
EVT_CHECKBOX(wxID_ANY, MyFrame::OnCheck) // button functions
wxEND_EVENT_TABLE()

IMPLEMENT_APP(MyApp)

